#!/bin/bash 
# projectid: 45600
# name: PATCH-X86-THIRD-0.1.1.sh
# date: 2023/05/29


script_name=$(basename $0)
PWD=/etc/cpeagent/upgrade/${script_name%.*}


ret_success=0
ret_success_restart=1
ret_success_reboot=2
ret_fail_roolback=6
ret_fail_others=7



log_exit() 
{
    echo `date` "$script_name upgrade: ${1} exit $2" 
    exit ${2}
}

update_phpandhttpd()
{
    target_version=7.4.33
    currentphpVersion=$(rpm -q --queryformat "%{VERSION}" php)
    if [[ $target_version == $currentphpVersion ]]; then
        log_exit "The current version is equal to the target version, skip PATCH!" $ret_fail_others
    elif [[ $(echo "$target_version $currentphpVersion" | tr " " "\n" | sort -V | tail -n 1) == $target_version ]]; then

        echo "currentphpVersion:${currentphpVersion}  less than target_version:${target_version}"
        rpm -Uvh ${PWD}/package/php-* 
        
        if [ $? -eq 0 ]; then
            echo "php update sucessed!" $ret_success
        else
            log_exit "php update failed!" $ret_fail_others
        fi
    else	
        log_exit "The current version is greater than the target version, skip PATCH!" $ret_fail_others
    fi

    target_version2=2.4.56
    currenthttpdVersion=$(rpm -q --queryformat "%{VERSION}" httpd)
      if [[ $target_version2 == $currenthttpdVersion ]]; then
        log_exit "The current version is equal to the target version, skip PATCH!" $ret_fail_others
    elif [[ $(echo "$target_version2 $currenthttpdVersion" | tr " " "\n" | sort -V | tail -n 1) == $target_version2 ]]; then

        echo "currenthttpdVersion:${currenthttpdVersion}  less than target_version:${target_version2}"
        rpm -Uvh ${PWD}/package/httpd/* 
        
        if [ $? -eq 0 ]; then
            echo "httpd update sucessed!" $ret_success
        else
            log_exit "httpd update failed!" $ret_fail_others
        fi
    else	
        log_exit "The current version is greater than the target version, skip PATCH!" $ret_fail_others
    fi  

	Httpd_Php_conf
    if [ $? -eq 0 ]; then
        systemctl restart httpd
        echo "modify php conf  sucessed!" $ret_success
    else
        log_exit "modify php conf  failed!" $ret_fail_others
    fi

    exit $ret_success_restart
}

Httpd_Php_conf()
{
    echo "modify httpd conf start"
    sed -i '$a\ServerSignature Off\nServerTokens Prod' /etc/httpd/conf/httpd.conf
    ret=$?
    if [[ $ret -eq 0 ]]; then
        echo "modify httpd conf success"
    else
        echo "modify httpd conf failed"
        return $ret
    fi

    echo "modify php conf start"
    sed -i 's/expose_php = On/expose_php = Off/' /etc/php.ini
    ret=$?
    if [[ $ret -eq 0 ]]; then
        echo "modify php conf success"
    else
        echo "modify php conf failed"
    fi
    return $ret
}

install()
{
    update_phpandhttpd
}

uninstall()
{
    exit $ret_success
}

if [ "$1" == "install" ];then
    install
elif [ "$1" == "uninstall" ]; then
    uninstall
else
    log_exit "invalid args" $ret_fail_others
fi

